(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Alpha_context.
Require TezosOfOCaml.Proto_alpha.Indexable.
Require TezosOfOCaml.Proto_alpha.Storage_sigs.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_l2_address.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_l2_batch.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_l2_context.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_l2_context_sig.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_l2_qty.

Module Counter_mismatch.
  Record record : Set := Build {
    account : Tx_rollup_l2_address.t;
    expected : int64;
    provided : int64 }.
  Definition with_account account (r : record) :=
    Build account r.(expected) r.(provided).
  Definition with_expected expected (r : record) :=
    Build r.(account) expected r.(provided).
  Definition with_provided provided (r : record) :=
    Build r.(account) r.(expected) provided.
End Counter_mismatch.
Definition Counter_mismatch := Counter_mismatch.record.

(** Init function; without side-effects in Coq *)
Definition init_module : unit :=
  let '_ :=
    Error_monad.register_error_kind Error_monad.Branch
      "tx_rollup_operation_counter_mismatch" "Operation counter mismatch"
      "A transaction rollup operation has been submitted with an incorrect counter"
      None
      (Data_encoding.obj3
        (Data_encoding.req None None "account" Tx_rollup_l2_address.encoding)
        (Data_encoding.req None None "requested" Data_encoding.int64_value)
        (Data_encoding.req None None "actual" Data_encoding.int64_value))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Counter_mismatch" then
            let '{|
              Counter_mismatch.account := account;
                Counter_mismatch.expected := expected;
                Counter_mismatch.provided := provided
                |} := cast Counter_mismatch payload in
            Some (account, expected, provided)
          else None
        end)
      (fun (function_parameter : Tx_rollup_l2_address.t * int64 * int64) =>
        let '(account, expected, provided) := function_parameter in
        Build_extensible "Counter_mismatch" Counter_mismatch
          {| Counter_mismatch.account := account;
            Counter_mismatch.expected := expected;
            Counter_mismatch.provided := provided |}) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Permanent
      "tx_rollup_incorrect_aggregated_signature"
      "Incorrect aggregated signature" "The aggregated signature is incorrect"
      None Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Incorrect_aggregated_signature" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "Incorrect_aggregated_signature" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Branch
      "tx_rollup_unknown_metadata" "Unknown metadata"
      "A public key index was provided but the account information for this index is not present in the context."
      None
      (Data_encoding.obj1
        (Data_encoding.req None None "idx" Data_encoding.int32_value))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Unallocated_metadata" then
            let 'i_value := cast int32 payload in
            Some i_value
          else None
        end)
      (fun (i_value : int32) =>
        Build_extensible "Unallocated_metadata" int32 i_value) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Permanent
      "tx_rollup_invalid_transaction" "Invalid transaction"
      "The signer signed multiple operations in the same transaction. He must gather all the contents in a single operation"
      None
      (Data_encoding.obj1
        (Data_encoding.req None None "pk" Tx_rollup_l2_context.pk_encoding))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Multiple_operations_for_signer" then
            let 'idx := cast Bls_signature.pk payload in
            Some idx
          else None
        end)
      (fun (idx : Bls_signature.pk) =>
        Build_extensible "Multiple_operations_for_signer" Bls_signature.pk idx)
    in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Permanent
      "tx_rollup_invalid_transaction_encoding" "Invalid transaction encoding"
      "The transaction could not be encoded to bytes" None Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Invalid_transaction_encoding" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "Invalid_transaction_encoding" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Permanent
      "tx_rollup_invalid_batch_encoding" "Invalid batch encoding"
      "The batch could not be encoded to bytes" None Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Invalid_batch_encoding" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "Invalid_batch_encoding" unit tt) in
  Error_monad.register_error_kind Error_monad.Permanent
    "tx_rollup_invalid_operation_destination" "Invalid operation destination"
    "The withdraw operation is not implemented yet" None Data_encoding.empty
    (fun (function_parameter : Error_monad._error) =>
      match function_parameter with
      | Build_extensible tag _ payload =>
        if String.eqb tag "Invalid_operation_destination" then
          Some tt
        else None
      end)
    (fun (function_parameter : unit) =>
      let '_ := function_parameter in
      Build_extensible "Invalid_operation_destination" unit tt).

Definition Address_indexes :=
  Map.Make
    {|
      Compare.COMPARABLE.compare := Tx_rollup_l2_address.compare
    |}.

Definition Ticket_indexes :=
  Map.Make
    {|
      Compare.COMPARABLE.compare := Alpha_context.Ticket_hash.compare
    |}.

Definition address_indexes : Set :=
  Address_indexes.(Map.S.t) (Indexable.index Tx_rollup_l2_address.t).

Definition ticket_indexes : Set :=
  Ticket_indexes.(Map.S.t) (Indexable.index Alpha_context.Ticket_hash.t).

Module indexes.
  Record record : Set := Build {
    address_indexes : address_indexes;
    ticket_indexes : ticket_indexes }.
  Definition with_address_indexes address_indexes (r : record) :=
    Build address_indexes r.(ticket_indexes).
  Definition with_ticket_indexes ticket_indexes (r : record) :=
    Build r.(address_indexes) ticket_indexes.
End indexes.
Definition indexes := indexes.record.

Definition address_indexes_to_list {A : Set}
  (x_value : Address_indexes.(Map.S.t) A) : list (Tx_rollup_l2_address.t * A) :=
  let seq := Address_indexes.(Map.S.to_seq) x_value in
  Seq.fold_left
    (fun (acc_value : list (Tx_rollup_l2_address.t * A)) =>
      fun (x_value : Tx_rollup_l2_address.t * A) => cons x_value acc_value) nil
    seq.

Definition address_indexes_of_list {A : Set}
  (l_value : list (Tx_rollup_l2_address.t * A)) : Address_indexes.(Map.S.t) A :=
  let seq :=
    List.fold_left
      (fun (seq : Seq.t (Tx_rollup_l2_address.t * A)) =>
        fun (x_value : Tx_rollup_l2_address.t * A) => Seq.cons_value x_value seq)
      Seq.empty l_value in
  Address_indexes.(Map.S.of_seq) seq.

Definition ticket_indexes_to_list {A : Set}
  (x_value : Ticket_indexes.(Map.S.t) A)
  : list (Alpha_context.Ticket_hash.t * A) :=
  let seq := Ticket_indexes.(Map.S.to_seq) x_value in
  Seq.fold_left
    (fun (acc_value : list (Alpha_context.Ticket_hash.t * A)) =>
      fun (x_value : Alpha_context.Ticket_hash.t * A) => cons x_value acc_value)
    nil seq.

Definition ticket_indexes_of_list {A : Set}
  (l_value : list (Alpha_context.Ticket_hash.t * A))
  : Ticket_indexes.(Map.S.t) A :=
  let seq :=
    List.fold_left
      (fun (seq : Seq.t (Alpha_context.Ticket_hash.t * A)) =>
        fun (x_value : Alpha_context.Ticket_hash.t * A) =>
          Seq.cons_value x_value seq) Seq.empty l_value in
  Ticket_indexes.(Map.S.of_seq) seq.

Definition encoding_indexes : Data_encoding.t indexes :=
  (let arg :=
    Data_encoding.conv
      (fun (function_parameter : indexes) =>
        let '{|
          indexes.address_indexes := address_indexes;
            indexes.ticket_indexes := ticket_indexes
            |} := function_parameter in
        ((address_indexes_to_list address_indexes),
          (ticket_indexes_to_list ticket_indexes)))
      (fun (function_parameter :
        list (Tx_rollup_l2_address.t * Indexable.index Tx_rollup_l2_address.t) *
          list
            (Alpha_context.Ticket_hash.t *
              Indexable.index Alpha_context.Ticket_hash.t)) =>
        let '(address_indexes_list, ticket_indexes_list) := function_parameter
          in
        let address_indexes := address_indexes_of_list address_indexes_list in
        let ticket_indexes := ticket_indexes_of_list ticket_indexes_list in
        {| indexes.address_indexes := address_indexes;
          indexes.ticket_indexes := ticket_indexes |}) in
  fun (eta :
    Data_encoding.encoding
      (list (Tx_rollup_l2_address.t * Indexable.index Tx_rollup_l2_address.t) *
        list
          (Alpha_context.Ticket_hash.t *
            Indexable.index Alpha_context.Ticket_hash.t))) => arg None eta)
    (Data_encoding.tup2
      (Data_encoding.list_value None
        (Data_encoding.tup2 Tx_rollup_l2_address.encoding
          Tx_rollup_l2_address.Indexable.index_encoding))
      (Data_encoding.list_value None
        (Data_encoding.tup2 Alpha_context.Ticket_hash.encoding
          Tx_rollup_l2_context_sig.Ticket_indexable.(Indexable.INDEXABLE.index_encoding)))).

Module Message_result.
  (** Records for the constructor parameters *)
  Module ConstructorRecords_transaction_result.
    Module transaction_result.
      Module Transaction_failure.
        Record record {index reason : Set} : Set := Build {
          index : index;
          reason : reason }.
        Arguments record : clear implicits.
        Definition with_index {t_index t_reason} index
          (r : record t_index t_reason) :=
          Build t_index t_reason index r.(reason).
        Definition with_reason {t_index t_reason} reason
          (r : record t_index t_reason) :=
          Build t_index t_reason r.(index) reason.
      End Transaction_failure.
      Definition Transaction_failure_skeleton := Transaction_failure.record.
    End transaction_result.
  End ConstructorRecords_transaction_result.
  Import ConstructorRecords_transaction_result.
  
  Reserved Notation "'transaction_result.Transaction_failure".
  
  Inductive transaction_result : Set :=
  | Transaction_success : transaction_result
  | Transaction_failure :
    'transaction_result.Transaction_failure -> transaction_result
  
  where "'transaction_result.Transaction_failure" :=
    (transaction_result.Transaction_failure_skeleton int Error_monad._error).
  
  Module transaction_result.
    Include ConstructorRecords_transaction_result.transaction_result.
    Definition Transaction_failure := 'transaction_result.Transaction_failure.
  End transaction_result.
  
  Inductive deposit_result : Set :=
  | Deposit_success : indexes -> deposit_result
  | Deposit_failure : Error_monad._error -> deposit_result.
  
  Definition encoding_transaction_result
    : Data_encoding.encoding transaction_result :=
    Data_encoding.union None
      [
        let kind_value := "transaction_success" in
        Data_encoding.case_value kind_value None (Data_encoding.Tag 0)
          (Data_encoding.constant kind_value)
          (fun (function_parameter : transaction_result) =>
            match function_parameter with
            | Transaction_success => Some tt
            | _ => None
            end)
          (fun (function_parameter : unit) =>
            let '_ := function_parameter in
            Transaction_success);
        let kind_value := "transaction_failure" in
        Data_encoding.case_value kind_value None (Data_encoding.Tag 1)
          (Data_encoding.obj1
            (Data_encoding.req None None kind_value
              (Data_encoding.obj2
                (Data_encoding.req None None "transaction_index"
                  Data_encoding.int31)
                (Data_encoding.req None None "reason"
                  Error_monad.error_encoding))))
          (fun (function_parameter : transaction_result) =>
            match function_parameter with
            |
              Transaction_failure {|
                transaction_result.Transaction_failure.index := index_value;
                  transaction_result.Transaction_failure.reason
                    := reason
                  |} => Some (index_value, reason)
            | _ => None
            end)
          (fun (function_parameter : int * Error_monad._error) =>
            let '(index_value, reason) := function_parameter in
            Transaction_failure
              {|
                transaction_result.Transaction_failure.index :=
                  index_value;
                transaction_result.Transaction_failure.reason :=
                  reason |})
      ].
  
  Definition encoding_deposit_result : Data_encoding.encoding deposit_result :=
    Data_encoding.union None
      [
        let kind_value := "deposit_success" in
        Data_encoding.case_value kind_value None (Data_encoding.Tag 0)
          (Data_encoding.obj1
            (Data_encoding.req None None kind_value encoding_indexes))
          (fun (function_parameter : deposit_result) =>
            match function_parameter with
            | Deposit_success indexes => Some indexes
            | _ => None
            end) (fun (indexes : indexes) => Deposit_success indexes);
        let kind_value := "deposit_failure" in
        Data_encoding.case_value kind_value None (Data_encoding.Tag 1)
          (Data_encoding.obj1
            (Data_encoding.req None None kind_value
              (Data_encoding.obj1
                (Data_encoding.req None None "reason"
                  Error_monad.error_encoding))))
          (fun (function_parameter : deposit_result) =>
            match function_parameter with
            | Deposit_failure reason => Some reason
            | _ => None
            end)
          (fun (reason : Error_monad._error) => Deposit_failure reason)
      ].
  
  Module Batch_V1.
    (** Records for the constructor parameters *)
    Module ConstructorRecords_t.
      Module t.
        Module Batch_result.
          Record record {results indexes : Set} : Set := Build {
            results : results;
            indexes : indexes }.
          Arguments record : clear implicits.
          Definition with_results {t_results t_indexes} results
            (r : record t_results t_indexes) :=
            Build t_results t_indexes results r.(indexes).
          Definition with_indexes {t_results t_indexes} indexes
            (r : record t_results t_indexes) :=
            Build t_results t_indexes r.(results) indexes.
        End Batch_result.
        Definition Batch_result_skeleton := Batch_result.record.
      End t.
    End ConstructorRecords_t.
    Import ConstructorRecords_t.
    
    Reserved Notation "'t.Batch_result".
    
    Inductive t : Set :=
    | Batch_result : 't.Batch_result -> t
    
    where "'t.Batch_result" :=
      (t.Batch_result_skeleton
        (list
          (Tx_rollup_l2_batch.V1.transaction Indexable.unknown *
            transaction_result)) indexes).
    
    Module t.
      Include ConstructorRecords_t.t.
      Definition Batch_result := 't.Batch_result.
    End t.
    
    Definition encoding : Data_encoding.encoding t :=
      Data_encoding.conv
        (fun (function_parameter : t) =>
          let
            'Batch_result {|
              t.Batch_result.results := results;
                t.Batch_result.indexes := indexes
                |} := function_parameter in
          (results, indexes))
        (fun (function_parameter :
          list
            (Tx_rollup_l2_batch.V1.transaction Indexable.unknown *
              transaction_result) * indexes) =>
          let '(results, indexes) := function_parameter in
          Batch_result
            {| t.Batch_result.results := results;
              t.Batch_result.indexes := indexes |}) None
        (Data_encoding.obj2
          (Data_encoding.req None None "results"
            (Data_encoding.list_value None
              (Data_encoding.tup2
                (Data_encoding.Compact.make
                  (Some (Variant.Build "Uint8" unit tt))
                  Tx_rollup_l2_batch.V1.compact_transaction_signer_index)
                encoding_transaction_result)))
          (Data_encoding.req None None "allocated_indexes" encoding_indexes)).
    
    Definition module :=
      {|
        Storage_sigs.VALUE.encoding := encoding
      |}.
  End Batch_V1.
  Definition Batch_V1 := Batch_V1.module.
  
  Inductive t : Set :=
  | Deposit_result : deposit_result -> t
  | Batch_V1_result : Batch_V1.(Storage_sigs.VALUE.t) -> t.
  
  Definition encoding : Data_encoding.encoding t :=
    Data_encoding.union None
      [
        let kind_value := "deposit_result" in
        Data_encoding.case_value kind_value None (Data_encoding.Tag 0)
          (Data_encoding.obj1
            (Data_encoding.req None None kind_value
              encoding_deposit_result))
          (fun (function_parameter : t) =>
            match function_parameter with
            | Deposit_result result_value => Some result_value
            | _ => None
            end)
          (fun (result_value : deposit_result) =>
            Deposit_result result_value);
        let kind_value := "batch_v1_result" in
        Data_encoding.case_value kind_value None (Data_encoding.Tag 1)
          (Data_encoding.obj1
            (Data_encoding.req None None kind_value
              Batch_V1.(Storage_sigs.VALUE.encoding)))
          (fun (function_parameter : t) =>
            match function_parameter with
            | Batch_V1_result result_value => Some result_value
            | _ => None
            end)
          (fun (result_value : Batch_V1.(Storage_sigs.VALUE.t)) =>
            Batch_V1_result result_value)
      ].
End Message_result.

Module Make.
  Class FArgs {Context_t : Set} {Context_m : Set -> Set} := {
    Context :
      Tx_rollup_l2_context_sig.CONTEXT (t := Context_t) (m := Context_m);
  }.
  Arguments Build_FArgs {_ _}.
  
  Definition ctxt `{FArgs} : Set :=
    Context.(Tx_rollup_l2_context_sig.CONTEXT.t).
  
  (** [get_index ctxt get_or_associate indexable] gets or associates [indexable]
      in the [ctxt] using [get_or_associate]. It returns the context, whether
      the index was created or existed, and finally, the index.

      If a [Value v] was given there are two possibilities:

      {ul {li The value was already associated to an index in previous
              operations. Thus, we return [None].}
          {li The value is not already associated and we create an index.
              Thus, we return [Some v] so it can be returned in the list
              of created indexes (see {!indexes}).}} *)
  Definition get_index `{FArgs} {A B : Set}
    (ctxt : A)
    (get_or_associate :
      A -> B ->
      Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
        (A * Tx_rollup_l2_context_sig.created_existed * Indexable.index B))
    (indexable : Indexable.t B)
    : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
      (A * option B * Indexable.index B) :=
    match Indexable.destruct indexable with
    | Either.Right v_value =>
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
        (get_or_associate ctxt v_value)
        (fun function_parameter =>
          let '(ctxt, created, idx) := function_parameter in
          let created :=
            match created with
            | Tx_rollup_l2_context_sig.Existed => None
            | Tx_rollup_l2_context_sig.Created => Some v_value
            end in
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
            (ctxt, created, idx))
    | Either.Left i_value =>
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
        (ctxt, None, i_value)
    end.
  
  Definition address_index `{FArgs}
    (ctxt : Context.(Tx_rollup_l2_context_sig.CONTEXT.t))
    (indexable : Indexable.t Tx_rollup_l2_address.t)
    : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
      (Context.(Tx_rollup_l2_context_sig.CONTEXT.t) *
        option Tx_rollup_l2_address.t * Indexable.index Tx_rollup_l2_address.t) :=
    get_index ctxt
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Address_index_get_or_associate_index)
      indexable.
  
  Definition ticket_index `{FArgs}
    (ctxt : Context.(Tx_rollup_l2_context_sig.CONTEXT.t))
    (indexable : Indexable.t Alpha_context.Ticket_hash.t)
    : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
      (Context.(Tx_rollup_l2_context_sig.CONTEXT.t) *
        option Alpha_context.Ticket_hash.t *
        Indexable.index Alpha_context.Ticket_hash.t) :=
    get_index ctxt
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Ticket_index_get_or_associate_index)
      indexable.
  
  Definition address_of_signer_index `{FArgs}
    (idx : Tx_rollup_l2_batch.Signer_indexable.(Indexable.VALUE.index))
    : Tx_rollup_l2_address.Indexable.index :=
    Indexable.index_exn (Indexable.to_int32 idx).
  
  Definition signer_of_address_index `{FArgs}
    (idx : Tx_rollup_l2_address.Indexable.index)
    : Tx_rollup_l2_batch.Signer_indexable.(Indexable.VALUE.index) :=
    Indexable.index_exn (Indexable.to_int32 idx).
  
  Definition empty_indexes `{FArgs} : indexes :=
    {| indexes.address_indexes := Address_indexes.(Map.S.empty);
      indexes.ticket_indexes := Ticket_indexes.(Map.S.empty) |}.
  
  Definition add_to_addr_indexes `{FArgs} {A : Set}
    (addr_indexes : Address_indexes.(Map.S.t) A)
    (function_parameter : option Tx_rollup_l2_address.t * A)
    : Address_indexes.(Map.S.t) A :=
    let '(v_value, idx) := function_parameter in
    match v_value with
    | Some v_value => Address_indexes.(Map.S.add) v_value idx addr_indexes
    | None => addr_indexes
    end.
  
  Definition add_to_ticket_indexes `{FArgs} {A : Set}
    (ticket_indexes : Ticket_indexes.(Map.S.t) A)
    (function_parameter : option Alpha_context.Ticket_hash.t * A)
    : Ticket_indexes.(Map.S.t) A :=
    let '(v_value, idx) := function_parameter in
    match v_value with
    | Some v_value => Ticket_indexes.(Map.S.add) v_value idx ticket_indexes
    | None => ticket_indexes
    end.
  
  Definition add_addr_to_indexes `{FArgs}
    (indexes : indexes) (addr : Tx_rollup_l2_address.t)
    (idx : Indexable.index Tx_rollup_l2_address.t) : indexes :=
    indexes.with_address_indexes
      (Address_indexes.(Map.S.add) addr idx indexes.(indexes.address_indexes))
      indexes.
  
  (** [add_indexes indexes (addr, aidx) (ticket, tidx)] adds to [indexes].
      [addr] and [ticket] are optional values, if a some value is given,
      it is supposed to be added in [indexes], otherwise it is ignored.

      See {!get_index} for more information. *)
  Definition add_indexes `{FArgs}
    (indexes : indexes)
    (addr :
      option Tx_rollup_l2_address.t * Indexable.index Tx_rollup_l2_address.t)
    (ticket :
      option Alpha_context.Ticket_hash.t *
        Indexable.index Alpha_context.Ticket_hash.t) : indexes :=
    {|
      indexes.address_indexes :=
        add_to_addr_indexes indexes.(indexes.address_indexes) addr;
      indexes.ticket_indexes :=
        add_to_ticket_indexes indexes.(indexes.ticket_indexes) ticket |}.
  
  (** [get_metadata ctxt idx] returns the metadata associated to [idx] in
      [ctxt]. It must have an associated metadata in the context, otherwise,
      something went wrong in {!check_signature}. *)
  Definition get_metadata `{FArgs}
    (ctxt : ctxt) (idx : Tx_rollup_l2_context_sig.address_index)
    : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
      Tx_rollup_l2_context_sig.metadata :=
    Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
      (Context.(Tx_rollup_l2_context_sig.CONTEXT.Address_metadata_get) ctxt idx)
      (fun metadata =>
        match metadata with
        | None =>
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.fail)
            (Build_extensible "Unallocated_metadata" int32
              (Indexable.to_int32 idx))
        | Some metadata =>
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
            metadata
        end).
  
  (** [get_metadata_signer] gets the metadata for a signer using {!get_metadata}.
      It transforms a signer index to an address one. *)
  Definition get_metadata_signer `{FArgs}
    (ctxt : ctxt)
    (signer_idx : Tx_rollup_l2_batch.Signer_indexable.(Indexable.VALUE.index))
    : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
      Tx_rollup_l2_context_sig.metadata :=
    get_metadata ctxt (address_of_signer_index signer_idx).
  
  (** [transfers ctxt source_idx destination_idx tidx amount] transfers [amount]
      from [source_idx] to [destination_idx] of [tidx]. *)
  Definition transfer `{FArgs}
    (ctxt : Context.(Tx_rollup_l2_context_sig.CONTEXT.t))
    (source_idx : Tx_rollup_l2_context_sig.address_index)
    (destination_idx : Tx_rollup_l2_context_sig.address_index)
    (tidx : Tx_rollup_l2_context_sig.ticket_index) (amount : Tx_rollup_l2_qty.t)
    : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
      Context.(Tx_rollup_l2_context_sig.CONTEXT.t) :=
    Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
      (Context.(Tx_rollup_l2_context_sig.CONTEXT.Ticket_ledger_spend) ctxt tidx
        source_idx amount)
      (fun ctxt =>
        Context.(Tx_rollup_l2_context_sig.CONTEXT.Ticket_ledger_credit) ctxt
          tidx destination_idx amount).
  
  (** [deposit ctxt aidx tidx amount] credits [amount] of [tidx] to [aidx].
      They are deposited from the layer1 and created in the layer2 context, but,
      we only handle the creation part (i.e. in the layer2) in this module. *)
  Definition deposit `{FArgs}
    (ctxt : Context.(Tx_rollup_l2_context_sig.CONTEXT.t))
    (aidx : Tx_rollup_l2_context_sig.address_index)
    (tidx : Tx_rollup_l2_context_sig.ticket_index) (amount : Tx_rollup_l2_qty.t)
    : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
      Context.(Tx_rollup_l2_context_sig.CONTEXT.t) :=
    Context.(Tx_rollup_l2_context_sig.CONTEXT.Ticket_ledger_credit) ctxt tidx
      aidx amount.
  
  Module Batch_V1.
    (** [operation_with_signer_index ctxt indexes op] takes an operation
        and performs multiple get/sets on the context to return an operation
        where the signer is replaced by its index.

        It performs on the [ctxt]:
        {ul {li If the signer is an index, we read the public key from the
                [ctxt].}
            {li If the signer is a public key, we associate a new index to
                it in the [ctxt]. The public key is also added to the metadata
                if not already present.}}

        {b Note:} If the context already contains all the required information,
        we only read from it. *)
    Definition operation_with_signer_index `{FArgs} {content : Set}
      (ctxt : ctxt) (indexes : indexes)
      (op : Tx_rollup_l2_batch.V1.operation content)
      : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
        (ctxt * indexes * Tx_rollup_l2_batch.V1.operation content *
          Bls_signature.pk) :=
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
        match Indexable.destruct op.(Tx_rollup_l2_batch.V1.operation.signer)
          with
        | Either.Left pk_index =>
          let address_index := address_of_signer_index pk_index in
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
            (get_metadata ctxt address_index)
            (fun metadata =>
              let pk := metadata.(Tx_rollup_l2_context_sig.metadata.public_key)
                in
              Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                (ctxt, indexes, pk, address_index))
        | Either.Right pk =>
          let addr := Tx_rollup_l2_address.of_bls_pk pk in
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
            (Context.(Tx_rollup_l2_context_sig.CONTEXT.Address_index_get_or_associate_index)
              ctxt addr)
            (fun function_parameter =>
              let '(ctxt, created, idx) := function_parameter in
              match created with
              | Tx_rollup_l2_context_sig.Existed =>
                Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                  (Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                    (Context.(Tx_rollup_l2_context_sig.CONTEXT.Address_metadata_get)
                      ctxt idx)
                    (fun metadata =>
                      match metadata with
                      | Some _ =>
                        Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                          ctxt
                      | None =>
                        Context.(Tx_rollup_l2_context_sig.CONTEXT.Address_metadata_init_with_public_key)
                          ctxt idx pk
                      end))
                  (fun ctxt =>
                    Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                      (ctxt, indexes, pk, idx))
              | Tx_rollup_l2_context_sig.Created =>
                let indexes := add_addr_to_indexes indexes addr idx in
                Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                  (Context.(Tx_rollup_l2_context_sig.CONTEXT.Address_metadata_init_with_public_key)
                    ctxt idx pk)
                  (fun ctxt =>
                    Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                      (ctxt, indexes, pk, idx))
              end)
        end
        (fun function_parameter =>
          let '(ctxt, indexes, pk, idx) := function_parameter in
          let op :=
            Tx_rollup_l2_batch.V1.operation.with_signer
              (signer_of_address_index idx) op in
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
            (ctxt, indexes, op, pk)).
    
    (** [check_transaction ctxt indexes transmitted transaction] performs an
        *active* check of an operation.
        We consider this as an *active* check because the function is likely to
        write in the [ctxt], since it replaces the signer's public key
        (if provided) by its index in {!operation_with_signer_index}.

        Outside of the active preprocessing, we check that a signer signs
        at most one operation in the [transaction].

        It also associates the signer to the bytes representation of a
        transaction in [transmitted], which is used to check the aggregated
        signature. *)
    Definition check_transaction `{FArgs}
      (ctxt : ctxt) (indexes : indexes)
      (transmitted : list (Bls_signature.pk * bytes))
      (transaction : Tx_rollup_l2_batch.V1.transaction Indexable.unknown)
      : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
        (ctxt * indexes * list (Bls_signature.pk * bytes) *
          list (Tx_rollup_l2_batch.V1.operation Indexable.unknown)) :=
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
        match
          Data_encoding.Binary.to_bytes_opt None
            (Data_encoding.Compact.make (Some (Variant.Build "Uint8" unit tt))
              Tx_rollup_l2_batch.V1.compact_transaction) transaction with
        | Some buf =>
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
            buf
        | None =>
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.fail)
            (Build_extensible "Invalid_transaction_encoding" unit tt)
        end
        (fun buf =>
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
            (Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.list_fold_left_m)
              (fun (function_parameter :
                ctxt * indexes * list (Bls_signature.pk * bytes) *
                  list Bls_signature.pk *
                  list (Tx_rollup_l2_batch.V1.operation Indexable.unknown)) =>
                let '(ctxt, indexes, transmitted, signers, ops) :=
                  function_parameter in
                fun (op : Tx_rollup_l2_batch.V1.operation Indexable.unknown) =>
                  Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                    (operation_with_signer_index ctxt indexes op)
                    (fun function_parameter =>
                      let '(ctxt, indexes, op, pk) := function_parameter in
                      let compare
                        (x_value : Bls_signature.pk)
                        (y_value : Bls_signature.pk) : int :=
                        Bytes.compare (Bls_signature.pk_to_bytes x_value)
                          (Bls_signature.pk_to_bytes y_value) in
                      let equal
                        (x_value : Bls_signature.pk)
                        (y_value : Bls_signature.pk) : bool :=
                        (compare x_value y_value) =i 0 in
                      if List.mem equal pk signers then
                        Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.fail)
                          (Build_extensible "Multiple_operations_for_signer"
                            Bls_signature.pk pk)
                      else
                        Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                          (ctxt, indexes, (cons (pk, buf) transmitted),
                            (cons pk signers), (cons op ops))))
              (ctxt, indexes, transmitted, nil, nil) transaction)
            (fun function_parameter =>
              let '(ctxt, indexes, transmitted, _, rev_ops) :=
                function_parameter in
              Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                (ctxt, indexes, transmitted, (List.rev rev_ops)))).
    
    Definition check_signature `{FArgs}
      (ctxt : ctxt)
      (function_parameter : Tx_rollup_l2_batch.V1.t Indexable.unknown)
      : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
        (ctxt * indexes * Tx_rollup_l2_batch.V1.t Indexable.unknown) :=
      let
        '{|
          Tx_rollup_l2_batch.V1.t.contents := transactions;
            Tx_rollup_l2_batch.V1.t.aggregated_signature := aggregated_signature
            |} as batch := function_parameter in
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
        (Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.list_fold_left_m)
          (fun (function_parameter :
            ctxt * indexes * list (Bls_signature.pk * bytes) *
              list (Tx_rollup_l2_batch.V1.transaction Indexable.unknown)) =>
            let '(ctxt, indexes, transmitted, new_transactions) :=
              function_parameter in
            fun (transaction :
              Tx_rollup_l2_batch.V1.transaction Indexable.unknown) =>
              Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                (check_transaction ctxt indexes transmitted transaction)
                (fun function_parameter =>
                  let '(ctxt, indexes, transmitted, transaction) :=
                    function_parameter in
                  Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                    (ctxt, indexes, transmitted,
                      (cons transaction new_transactions))))
          (ctxt, empty_indexes, nil, nil) transactions)
        (fun function_parameter =>
          let '(ctxt, indexes, transmitted, rev_new_transactions) :=
            function_parameter in
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
            (Context.(Tx_rollup_l2_context_sig.CONTEXT.bls_verify) transmitted
              aggregated_signature)
            (fun b_value =>
              Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                (Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.fail_unless)
                  b_value
                  (Build_extensible "Incorrect_aggregated_signature" unit tt))
                (fun function_parameter =>
                  let '_ := function_parameter in
                  let batch :=
                    Tx_rollup_l2_batch.V1.t.with_contents
                      (List.rev rev_new_transactions) batch in
                  Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                    (ctxt, indexes, batch)))).
    
    (** [apply_operation_content ctxt source content] performs the transfer
        on the [ctxt]. The validity of the transfer is checked in
        the context itself, e.g. for an invalid balance.

        It also returns the potential created indexes:

        {ul {li The destination address index.}
            {li The ticket exchanged index.}} *)
    Definition apply_operation_content `{FArgs} {content : Set}
      (ctxt : ctxt) (indexes : indexes)
      (source_idx : Tx_rollup_l2_batch.Signer_indexable.(Indexable.VALUE.index))
      (function_parameter : Tx_rollup_l2_batch.V1.operation_content content)
      : Context.(Tx_rollup_l2_context_sig.CONTEXT.m) (ctxt * indexes) :=
      let '{|
        Tx_rollup_l2_batch.V1.operation_content.destination := destination;
          Tx_rollup_l2_batch.V1.operation_content.ticket_hash := ticket_hash;
          Tx_rollup_l2_batch.V1.operation_content.qty := qty
          |} := function_parameter in
      match destination with
      | Tx_rollup_l2_batch.Layer1 _ =>
        Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.fail)
          (Build_extensible "Invalid_operation_destination" unit tt)
      | Tx_rollup_l2_batch.Layer2 l2_dest =>
        Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
          (address_index ctxt l2_dest)
          (fun function_parameter =>
            let '(ctxt, created_addr, dest_idx) := function_parameter in
            Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
              (ticket_index ctxt ticket_hash)
              (fun function_parameter =>
                let '(ctxt, created_ticket, tidx) := function_parameter in
                let source_idx := address_of_signer_index source_idx in
                Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                  (transfer ctxt source_idx dest_idx tidx qty)
                  (fun ctxt =>
                    let indexes :=
                      add_indexes indexes (created_addr, dest_idx)
                        (created_ticket, tidx) in
                    Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                      (ctxt, indexes))))
      end.
    
    (** [check_counter ctxt signer counter] asserts that the provided [counter] is the
        successor of the one associated to the [signer] in the [ctxt]. *)
    Definition check_counter `{FArgs}
      (ctxt : ctxt)
      (signer : Tx_rollup_l2_batch.Signer_indexable.(Indexable.VALUE.t))
      (counter : int64) : Context.(Tx_rollup_l2_context_sig.CONTEXT.m) unit :=
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
        (get_metadata_signer ctxt signer)
        (fun metadata =>
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.fail_unless)
            (counter =i64
            (Int64.succ metadata.(Tx_rollup_l2_context_sig.metadata.counter)))
            (Build_extensible "Counter_mismatch" Counter_mismatch
              {|
                Counter_mismatch.account :=
                  Tx_rollup_l2_address.of_bls_pk
                    metadata.(Tx_rollup_l2_context_sig.metadata.public_key);
                Counter_mismatch.expected :=
                  metadata.(Tx_rollup_l2_context_sig.metadata.counter);
                Counter_mismatch.provided := counter |})).
    
    (** [apply_operation ctxt indexes op] checks the counter validity for the [op.signer] with
        {!check_counter}, and then calls {!apply_operation_content} for each content in [op]. *)
    Definition apply_operation `{FArgs}
      (ctxt : ctxt) (indexes : indexes)
      (function_parameter : Tx_rollup_l2_batch.V1.operation Indexable.unknown)
      : Context.(Tx_rollup_l2_context_sig.CONTEXT.m) (ctxt * indexes) :=
      let '{|
        Tx_rollup_l2_batch.V1.operation.signer := signer;
          Tx_rollup_l2_batch.V1.operation.counter := counter;
          Tx_rollup_l2_batch.V1.operation.contents := contents
          |} := function_parameter in
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
        (check_counter ctxt signer counter)
        (fun function_parameter =>
          let '_ := function_parameter in
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.list_fold_left_m)
            (fun (function_parameter : ctxt * indexes) =>
              let '(ctxt, indexes) := function_parameter in
              fun (content :
                Tx_rollup_l2_batch.V1.operation_content Indexable.unknown) =>
                apply_operation_content ctxt indexes signer content)
            (ctxt, indexes) contents).
    
    (** [apply_transaction ctxt indexes transaction] applies each operation in
        the [transaction]. It returns a {!transaction_result}, i.e. either
        every operation in the [transaction] succedeed and the [ctxt] is
        modified, or the [transaction] is a failure and the context
        is left untouched. *)
    Definition apply_transaction `{FArgs}
      (initial_ctxt : ctxt) (initial_indexes : indexes)
      (transaction : Tx_rollup_l2_batch.V1.transaction Indexable.unknown)
      : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
        (ctxt * indexes * Message_result.transaction_result) :=
      let fix fold (function_parameter : ctxt * indexes)
        : int -> list (Tx_rollup_l2_batch.V1.operation Indexable.unknown) ->
        Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
          (ctxt * indexes * Message_result.transaction_result) :=
        let '(ctxt, prev_indexes) := function_parameter in
        fun (index_value : int) =>
          fun (ops : list (Tx_rollup_l2_batch.V1.operation Indexable.unknown))
            =>
            match ops with
            | [] =>
              Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                (ctxt, prev_indexes, Message_result.Transaction_success)
            | cons op rst =>
              Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                (Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.catch)
                  (apply_operation ctxt prev_indexes op)
                  (fun (function_parameter : ctxt * indexes) =>
                    let '(ctxt, indexes) := function_parameter in
                    fold (ctxt, indexes) (index_value +i 1) rst)
                  (fun (reason : Error_monad._error) =>
                    Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                      (initial_ctxt, initial_indexes,
                        (Message_result.Transaction_failure
                          {|
                            Message_result.transaction_result.Transaction_failure.index
                              := index_value;
                            Message_result.transaction_result.Transaction_failure.reason
                              := reason |}))))
                (fun function_parameter =>
                  let '(ctxt, indexes, status) := function_parameter in
                  Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                    (ctxt, indexes, status))
            end in
      fold (initial_ctxt, initial_indexes) 0 transaction.
    
    (** [update_counters ctxt status transaction] updates the counters for
        the signers of operations in [transaction]. If the [transaction]
        failed because of a [Counter_mismatch] the counters are left
        untouched. *)
    Axiom update_counters : forall {A : Set},
      Context.(Tx_rollup_l2_context_sig.CONTEXT.t) ->
      Message_result.transaction_result ->
      list (Tx_rollup_l2_batch.V1.operation A) ->
      Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
        Context.(Tx_rollup_l2_context_sig.CONTEXT.t).
    
    Definition apply_batch `{FArgs}
      (ctxt : ctxt) (batch : Tx_rollup_l2_batch.V1.t Indexable.unknown)
      : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
        (ctxt * Message_result.Batch_V1.(Storage_sigs.VALUE.t)) :=
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
        (check_signature ctxt batch)
        (fun function_parameter =>
          let '(ctxt, indexes, batch) := function_parameter in
          let '{| Tx_rollup_l2_batch.V1.t.contents := contents |} := batch in
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
            (Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.list_fold_left_m)
              (fun (function_parameter :
                ctxt * indexes *
                  list
                    (Tx_rollup_l2_batch.V1.transaction Indexable.unknown *
                      Message_result.transaction_result)) =>
                let '(prev_ctxt, prev_indexes, results) := function_parameter in
                fun (transaction :
                  Tx_rollup_l2_batch.V1.transaction Indexable.unknown) =>
                  Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                    (apply_transaction prev_ctxt prev_indexes transaction)
                    (fun function_parameter =>
                      let '(new_ctxt, new_indexes, status) := function_parameter
                        in
                      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                        (update_counters new_ctxt status transaction)
                        (fun new_ctxt =>
                          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                            (new_ctxt, new_indexes,
                              (cons (transaction, status) results)))))
              (ctxt, indexes, nil) contents)
            (fun function_parameter =>
              let '(ctxt, indexes, rev_results) := function_parameter in
              let results := List.rev rev_results in
              Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                (ctxt,
                  (Message_result.Batch_V1.Batch_result
                    {|
                      Message_result.Batch_V1.t.Batch_result.results := results;
                      Message_result.Batch_V1.t.Batch_result.indexes := indexes
                      |})))).
  End Batch_V1.
  
  Definition apply_deposit `{FArgs}
    (initial_ctxt : ctxt)
    (function_parameter : Alpha_context.Tx_rollup_message.deposit)
    : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
      (ctxt * Message_result.deposit_result) :=
    let '{|
      Alpha_context.Tx_rollup_message.deposit.destination := destination;
        Alpha_context.Tx_rollup_message.deposit.ticket_hash := ticket_hash;
        Alpha_context.Tx_rollup_message.deposit.amount := amount
        |} := function_parameter in
    let apply_deposit (function_parameter : unit)
      : Context.(Tx_rollup_l2_context_sig.CONTEXT.m)
        (Context.(Tx_rollup_l2_context_sig.CONTEXT.t) * indexes) :=
      let '_ := function_parameter in
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
        (address_index initial_ctxt destination)
        (fun function_parameter =>
          let '(ctxt, created_addr, aidx) := function_parameter in
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
            (ticket_index ctxt (Indexable.value_value ticket_hash))
            (fun function_parameter =>
              let '(ctxt, created_ticket, tidx) := function_parameter in
              Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
                (deposit ctxt aidx tidx amount)
                (fun ctxt =>
                  let indexes :=
                    add_indexes empty_indexes (created_addr, aidx)
                      (created_ticket, tidx) in
                  Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
                    (ctxt, indexes)))) in
    Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.catch)
      (apply_deposit tt)
      (fun (function_parameter : ctxt * indexes) =>
        let '(ctxt, indexes) := function_parameter in
        Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
          (ctxt, (Message_result.Deposit_success indexes)))
      (fun (reason : Error_monad._error) =>
        Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
          (initial_ctxt, (Message_result.Deposit_failure reason))).
  
  Definition apply_message `{FArgs}
    (ctxt : ctxt) (msg : Alpha_context.Tx_rollup_message.t)
    : Context.(Tx_rollup_l2_context_sig.CONTEXT.m) (ctxt * Message_result.t) :=
    match msg with
    | Alpha_context.Tx_rollup_message.Deposit deposit =>
      Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
        (apply_deposit ctxt deposit)
        (fun function_parameter =>
          let '(ctxt, result_value) := function_parameter in
          Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
            (ctxt, (Message_result.Deposit_result result_value)))
    | Alpha_context.Tx_rollup_message.Batch str =>
      let batch :=
        Data_encoding.Binary.of_string_opt Tx_rollup_l2_batch.encoding str in
      match batch with
      | Some (Tx_rollup_l2_batch.V1 batch) =>
        Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.op_letstar)
          (Batch_V1.apply_batch ctxt batch)
          (fun function_parameter =>
            let '(ctxt, result_value) := function_parameter in
            Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX._return)
              (ctxt, (Message_result.Batch_V1_result result_value)))
      | None =>
        Context.(Tx_rollup_l2_context_sig.CONTEXT.Syntax).(Tx_rollup_l2_context_sig.SYNTAX.fail)
          (Build_extensible "Invalid_batch_encoding" unit tt)
      end
    end.
End Make.
